// ExcelHookAll.cpp : Implementation of DLL Exports.

#include "stdafx.h"
#include "resource.h"
#include "ExcelHookAll.h"
#include "log.h"
#include "ExcelHookAllApp.h"

#include <string>


CExcelHookAllModule _AtlModule;


// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
    switch(dwReason) 
    {
    case DLL_PROCESS_ATTACH:
        {
            char modulePath[MAX_PATH] = {'\0'};
            ::GetModuleFileName(hInstance, modulePath, MAX_PATH);
            ::PathRemoveFileSpec(modulePath);
            std::string logName = modulePath;
            logName += "\\excel.log";

            log::initialize(logName.c_str());

            _AtlModule.setInstance(hInstance);
            _AtlModule.setPath(modulePath);

        }
    	break;
    }
    
    return _AtlModule.DllMain(dwReason, lpReserved); 
}


// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
    return _AtlModule.DllCanUnloadNow();
}


// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}


STDAPI DllRegisterServer(void)
{
    HRESULT hr = _AtlModule.DllRegisterServer();
	return hr;
}


STDAPI DllUnregisterServer(void)
{
	HRESULT hr = _AtlModule.DllUnregisterServer();
    _AtlModule.excelRegistration(true);
	return hr;
}
