#ifndef EXCEL_HOOK_ALL_APP_H
#define EXCEL_HOOK_ALL_APP_H

#include "ApplicationSettings.h"

class CExcelHookAllModule: 
    public CAtlDllModuleT< CExcelHookAllModule >
{
public :
    CExcelHookAllModule()
    {

    }

    DECLARE_LIBID(LIBID_ExcelHookAllLib)
    DECLARE_REGISTRY_APPID_RESOURCEID(IDR_EXCELHOOKALL, "{694CCC24-5E7B-43AE-AF8D-C8019EC2940B}")

    HINSTANCE getInstance() const
    {
        return _hInstance;
    }

    void setInstance(HINSTANCE hInstance)
    {
        _hInstance = hInstance;
    }

    std::string getPath() const
    {
        return _path;
    }

    void setPath(const std::string &path)
    {
        _path = path;
    }

    static const DWORD msecWait = 60 * 1000;
    bool excelRegistration(bool reg)
    {
        std::string cmdLine;
        if (reg)
        {
            cmdLine = "/RegServer";
        }
        else
        {
            cmdLine = "/UnRegServer";
        }

        CApplicationSettings settings(getPath() + "\\ExcelHook.ini", "excel-hook");
        std::string excelPath = settings.readString("excel-path");

        STARTUPINFO startupInfo;
        PROCESS_INFORMATION processInfo;

        ::ZeroMemory(&startupInfo, sizeof(startupInfo));
        startupInfo.cb = sizeof(startupInfo);
        ::ZeroMemory(&processInfo, sizeof(processInfo));

        char cmdLine_[MAX_PATH];
        strcpy(cmdLine_, cmdLine.c_str());
        if (!::CreateProcess(excelPath.c_str(),
            cmdLine_, NULL, NULL, FALSE, 0, NULL,
            NULL, &startupInfo, &processInfo))
        {
            return false;
        }
        ::WaitForSingleObject(processInfo.hProcess, msecWait );

        ::CloseHandle(processInfo.hProcess);
        ::CloseHandle(processInfo.hThread);
        return true;
    }

private:
    // CApplicationSettings _applicationSetting;
    HINSTANCE _hInstance;
    std::string _path;
};


#endif // EXCEL_HOOK_ALL_APP_H
